var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Column, DeleteDateColumn, Entity, JoinColumn, ManyToOne, OneToMany, OneToOne, PrimaryColumn, PrimaryGeneratedColumn, } from 'typeorm';
let ExperimentModel = class ExperimentModel {
    uuid;
    status;
    bookingStart;
    bookingEnd;
    devices;
    roles;
    connections;
    serviceConfigurations;
    bookingID;
    deletedAt;
    additionalAttributes;
};
__decorate([
    PrimaryGeneratedColumn('uuid'),
    __metadata("design:type", String)
], ExperimentModel.prototype, "uuid", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], ExperimentModel.prototype, "status", void 0);
__decorate([
    Column({ nullable: true }),
    __metadata("design:type", String)
], ExperimentModel.prototype, "bookingStart", void 0);
__decorate([
    Column({ nullable: true }),
    __metadata("design:type", String)
], ExperimentModel.prototype, "bookingEnd", void 0);
__decorate([
    OneToMany(() => DeviceModel, device => device.experiment, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], ExperimentModel.prototype, "devices", void 0);
__decorate([
    OneToMany(() => RoleModel, role => role.experiment, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], ExperimentModel.prototype, "roles", void 0);
__decorate([
    OneToMany(() => PeerconnectionModel, peerconnection => peerconnection.experiment, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], ExperimentModel.prototype, "connections", void 0);
__decorate([
    OneToMany(() => ServiceConfigurationModel, serviceConfiguration => serviceConfiguration.experiment, { onDelete: 'CASCADE', cascade: true }),
    __metadata("design:type", Array)
], ExperimentModel.prototype, "serviceConfigurations", void 0);
__decorate([
    Column({ nullable: true }),
    __metadata("design:type", String)
], ExperimentModel.prototype, "bookingID", void 0);
__decorate([
    DeleteDateColumn(),
    __metadata("design:type", Date)
], ExperimentModel.prototype, "deletedAt", void 0);
__decorate([
    Column({ type: 'simple-json' }),
    __metadata("design:type", Object)
], ExperimentModel.prototype, "additionalAttributes", void 0);
ExperimentModel = __decorate([
    Entity({ name: 'Experiment' })
], ExperimentModel);
export { ExperimentModel };
let RoleModel = class RoleModel {
    uuid;
    name;
    description;
    configuration;
    experiment;
};
__decorate([
    PrimaryGeneratedColumn('uuid'),
    __metadata("design:type", String)
], RoleModel.prototype, "uuid", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], RoleModel.prototype, "name", void 0);
__decorate([
    Column('text', { nullable: true }),
    __metadata("design:type", Object)
], RoleModel.prototype, "description", void 0);
__decorate([
    Column('simple-json', { nullable: true }),
    __metadata("design:type", Object)
], RoleModel.prototype, "configuration", void 0);
__decorate([
    ManyToOne(() => ExperimentModel, experiment => experiment.roles),
    __metadata("design:type", ExperimentModel)
], RoleModel.prototype, "experiment", void 0);
RoleModel = __decorate([
    Entity({ name: 'Role' })
], RoleModel);
export { RoleModel };
let InstanceModel = class InstanceModel {
    uuid;
    url;
    token;
    codeUrl;
};
__decorate([
    PrimaryGeneratedColumn('uuid'),
    __metadata("design:type", String)
], InstanceModel.prototype, "uuid", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], InstanceModel.prototype, "url", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], InstanceModel.prototype, "token", void 0);
__decorate([
    Column({ nullable: true }),
    __metadata("design:type", String)
], InstanceModel.prototype, "codeUrl", void 0);
InstanceModel = __decorate([
    Entity({ name: 'Instance' })
], InstanceModel);
export { InstanceModel };
let DeviceModel = class DeviceModel {
    uuid;
    url;
    role;
    experiment;
    instance;
    resolvedDevice;
};
__decorate([
    PrimaryGeneratedColumn('uuid'),
    __metadata("design:type", String)
], DeviceModel.prototype, "uuid", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], DeviceModel.prototype, "url", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], DeviceModel.prototype, "role", void 0);
__decorate([
    ManyToOne(() => ExperimentModel, experiment => experiment.devices),
    __metadata("design:type", ExperimentModel)
], DeviceModel.prototype, "experiment", void 0);
__decorate([
    OneToOne(() => InstanceModel),
    JoinColumn(),
    __metadata("design:type", InstanceModel)
], DeviceModel.prototype, "instance", void 0);
__decorate([
    Column({ nullable: true }),
    __metadata("design:type", String)
], DeviceModel.prototype, "resolvedDevice", void 0);
DeviceModel = __decorate([
    Entity({ name: 'Device' })
], DeviceModel);
export { DeviceModel };
let PeerconnectionModel = class PeerconnectionModel {
    url;
    experiment;
};
__decorate([
    PrimaryColumn(),
    __metadata("design:type", String)
], PeerconnectionModel.prototype, "url", void 0);
__decorate([
    ManyToOne(() => ExperimentModel, experiment => experiment.connections),
    __metadata("design:type", ExperimentModel)
], PeerconnectionModel.prototype, "experiment", void 0);
PeerconnectionModel = __decorate([
    Entity({ name: 'Peerconnection' })
], PeerconnectionModel);
export { PeerconnectionModel };
let ServiceConfigurationModel = class ServiceConfigurationModel {
    uuid;
    serviceType;
    configuration;
    participants;
    experiment;
};
__decorate([
    PrimaryGeneratedColumn('uuid'),
    __metadata("design:type", String)
], ServiceConfigurationModel.prototype, "uuid", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], ServiceConfigurationModel.prototype, "serviceType", void 0);
__decorate([
    Column('simple-json', { nullable: true }),
    __metadata("design:type", Object)
], ServiceConfigurationModel.prototype, "configuration", void 0);
__decorate([
    OneToMany(() => ParticipantModel, participant => participant.serviceConfiguration, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], ServiceConfigurationModel.prototype, "participants", void 0);
__decorate([
    ManyToOne(() => ExperimentModel, experiment => experiment.serviceConfigurations),
    __metadata("design:type", ExperimentModel)
], ServiceConfigurationModel.prototype, "experiment", void 0);
ServiceConfigurationModel = __decorate([
    Entity({ name: 'ServiceConfiguration' })
], ServiceConfigurationModel);
export { ServiceConfigurationModel };
let ParticipantModel = class ParticipantModel {
    uuid;
    role;
    serviceId;
    config;
    serviceConfiguration;
};
__decorate([
    PrimaryGeneratedColumn('uuid'),
    __metadata("design:type", String)
], ParticipantModel.prototype, "uuid", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], ParticipantModel.prototype, "role", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], ParticipantModel.prototype, "serviceId", void 0);
__decorate([
    Column('simple-json'),
    __metadata("design:type", Object)
], ParticipantModel.prototype, "config", void 0);
__decorate([
    ManyToOne(() => ServiceConfigurationModel, serviceConfiguration => serviceConfiguration.participants),
    __metadata("design:type", ServiceConfigurationModel)
], ParticipantModel.prototype, "serviceConfiguration", void 0);
ParticipantModel = __decorate([
    Entity({ name: 'Participant' })
], ParticipantModel);
export { ParticipantModel };
let TemplateModel = class TemplateModel {
    uuid;
    name;
    description;
    configuration;
};
__decorate([
    PrimaryGeneratedColumn('uuid'),
    __metadata("design:type", String)
], TemplateModel.prototype, "uuid", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], TemplateModel.prototype, "name", void 0);
__decorate([
    Column(),
    __metadata("design:type", String)
], TemplateModel.prototype, "description", void 0);
__decorate([
    Column('simple-json'),
    __metadata("design:type", Object)
], TemplateModel.prototype, "configuration", void 0);
TemplateModel = __decorate([
    Entity({ name: 'Template' })
], TemplateModel);
export { TemplateModel };
export const Entities = [
    ExperimentModel,
    RoleModel,
    InstanceModel,
    DeviceModel,
    PeerconnectionModel,
    ServiceConfigurationModel,
    ParticipantModel,
    TemplateModel,
];
//# sourceMappingURL=model.js.map