import * as basicValidation from "./basicValidation.cjs";
/**
 * This function validates the inputs of a GET request on /experiments
 */
export function validateGetExperimentsInput(parameters) {
    if (parameters) {
        if (!basicValidation.validateExperimentStatusRequest(parameters["experimentStatus"])
            && parameters['experimentStatus'] !== undefined) {
            validateGetExperimentsInput.errors = basicValidation.validateExperimentStatusRequest.errors;
            return false;
        }
    }
    else {
        if (parameters !== undefined) {
            return false;
        }
    }
    return true;
}
/**
 * This function validates the outputs to a GET request on /experiments
 */
export function validateGetExperimentsOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!basicValidation.validateGetExperimentsResponse200Response(response.body)) {
            validateGetExperimentsOutput.errors = basicValidation.validateGetExperimentsResponse200Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetExperimentsOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a POST request on /experiments
 */
export function validatePostExperimentsInput(parameters, body) {
    if (parameters) {
        if (!basicValidation.validateChangedURLRequest(parameters["changedURL"])
            && parameters['changedURL'] !== undefined) {
            validatePostExperimentsInput.errors = basicValidation.validateChangedURLRequest.errors;
            return false;
        }
    }
    else {
        if (parameters !== undefined) {
            return false;
        }
    }
    if (!basicValidation.validatePostExperimentsRequestBodyRequest(body)) {
        validatePostExperimentsInput.errors = basicValidation.validatePostExperimentsRequestBodyRequest.errors;
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a POST request on /experiments
 */
export function validatePostExperimentsOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 201) {
        if (!basicValidation.validatePostExperimentsResponse201Response(response.body)) {
            validatePostExperimentsOutput.errors = basicValidation.validatePostExperimentsResponse201Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 202) {
        if (!basicValidation.validatePostExperimentsResponse202Response(response.body)) {
            validatePostExperimentsOutput.errors = basicValidation.validatePostExperimentsResponse202Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePostExperimentsOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a GET request on /experiments/{experiment_id}
 */
export function validateGetExperimentsByExperimentIdInput(parameters) {
    if (parameters) {
        if (!basicValidation.validateExperimentIdRequest(parameters["experiment_id"])) {
            validateGetExperimentsByExperimentIdInput.errors = basicValidation.validateExperimentIdRequest.errors;
            return false;
        }
    }
    else {
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a GET request on /experiments/{experiment_id}
 */
export function validateGetExperimentsByExperimentIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!basicValidation.validateGetExperimentsByExperimentIdResponse200Response(response.body)) {
            validateGetExperimentsByExperimentIdOutput.errors = basicValidation.validateGetExperimentsByExperimentIdResponse200Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetExperimentsByExperimentIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a PATCH request on /experiments/{experiment_id}
 */
export function validatePatchExperimentsByExperimentIdInput(parameters, body) {
    if (parameters) {
        if (!basicValidation.validateExperimentIdRequest(parameters["experiment_id"])) {
            validatePatchExperimentsByExperimentIdInput.errors = basicValidation.validateExperimentIdRequest.errors;
            return false;
        }
        if (!basicValidation.validateChangedURLRequest(parameters["changedURL"])
            && parameters['changedURL'] !== undefined) {
            validatePatchExperimentsByExperimentIdInput.errors = basicValidation.validateChangedURLRequest.errors;
            return false;
        }
    }
    else {
        return false;
    }
    if (body === undefined) {
        return true;
    }
    if (!basicValidation.validatePatchExperimentsByExperimentIdRequestBodyRequest(body)) {
        validatePatchExperimentsByExperimentIdInput.errors = basicValidation.validatePatchExperimentsByExperimentIdRequestBodyRequest.errors;
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a PATCH request on /experiments/{experiment_id}
 */
export function validatePatchExperimentsByExperimentIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!basicValidation.validatePatchExperimentsByExperimentIdResponse200Response(response.body)) {
            validatePatchExperimentsByExperimentIdOutput.errors = basicValidation.validatePatchExperimentsByExperimentIdResponse200Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 202) {
        if (!basicValidation.validatePatchExperimentsByExperimentIdResponse202Response(response.body)) {
            validatePatchExperimentsByExperimentIdOutput.errors = basicValidation.validatePatchExperimentsByExperimentIdResponse202Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePatchExperimentsByExperimentIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a DELETE request on /experiments/{experiment_id}
 */
export function validateDeleteExperimentsByExperimentIdInput(parameters) {
    if (parameters) {
        if (!basicValidation.validateExperimentIdRequest(parameters["experiment_id"])) {
            validateDeleteExperimentsByExperimentIdInput.errors = basicValidation.validateExperimentIdRequest.errors;
            return false;
        }
    }
    else {
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a DELETE request on /experiments/{experiment_id}
 */
export function validateDeleteExperimentsByExperimentIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 204) {
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateDeleteExperimentsByExperimentIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a GET request on /templates
 */
export function validateGetTemplatesInput() {
    return true;
}
/**
 * This function validates the outputs to a GET request on /templates
 */
export function validateGetTemplatesOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!basicValidation.validateGetTemplatesResponse200Response(response.body)) {
            validateGetTemplatesOutput.errors = basicValidation.validateGetTemplatesResponse200Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetTemplatesOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a POST request on /templates
 */
export function validatePostTemplatesInput(body) {
    if (!basicValidation.validatePostTemplatesRequestBodyRequest(body)) {
        validatePostTemplatesInput.errors = basicValidation.validatePostTemplatesRequestBodyRequest.errors;
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a POST request on /templates
 */
export function validatePostTemplatesOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 201) {
        if (!basicValidation.validatePostTemplatesResponse201Response(response.body)) {
            validatePostTemplatesOutput.errors = basicValidation.validatePostTemplatesResponse201Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 202) {
        if (!basicValidation.validatePostTemplatesResponse202Response(response.body)) {
            validatePostTemplatesOutput.errors = basicValidation.validatePostTemplatesResponse202Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePostTemplatesOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a GET request on /templates/{template_id}
 */
export function validateGetTemplatesByTemplateIdInput(parameters) {
    if (parameters) {
        if (!basicValidation.validateTemplateIdRequest(parameters["template_id"])) {
            validateGetTemplatesByTemplateIdInput.errors = basicValidation.validateTemplateIdRequest.errors;
            return false;
        }
    }
    else {
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a GET request on /templates/{template_id}
 */
export function validateGetTemplatesByTemplateIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!basicValidation.validateGetTemplatesByTemplateIdResponse200Response(response.body)) {
            validateGetTemplatesByTemplateIdOutput.errors = basicValidation.validateGetTemplatesByTemplateIdResponse200Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetTemplatesByTemplateIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a PATCH request on /templates/{template_id}
 */
export function validatePatchTemplatesByTemplateIdInput(parameters, body) {
    if (parameters) {
        if (!basicValidation.validateTemplateIdRequest(parameters["template_id"])) {
            validatePatchTemplatesByTemplateIdInput.errors = basicValidation.validateTemplateIdRequest.errors;
            return false;
        }
    }
    else {
        return false;
    }
    if (!basicValidation.validatePatchTemplatesByTemplateIdRequestBodyRequest(body)) {
        validatePatchTemplatesByTemplateIdInput.errors = basicValidation.validatePatchTemplatesByTemplateIdRequestBodyRequest.errors;
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a PATCH request on /templates/{template_id}
 */
export function validatePatchTemplatesByTemplateIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!basicValidation.validatePatchTemplatesByTemplateIdResponse200Response(response.body)) {
            validatePatchTemplatesByTemplateIdOutput.errors = basicValidation.validatePatchTemplatesByTemplateIdResponse200Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 202) {
        if (!basicValidation.validatePatchTemplatesByTemplateIdResponse202Response(response.body)) {
            validatePatchTemplatesByTemplateIdOutput.errors = basicValidation.validatePatchTemplatesByTemplateIdResponse202Response.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePatchTemplatesByTemplateIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
/**
 * This function validates the inputs of a DELETE request on /templates/{template_id}
 */
export function validateDeleteTemplatesByTemplateIdInput(parameters) {
    if (parameters) {
        if (!basicValidation.validateTemplateIdRequest(parameters["template_id"])) {
            validateDeleteTemplatesByTemplateIdInput.errors = basicValidation.validateTemplateIdRequest.errors;
            return false;
        }
    }
    else {
        return false;
    }
    return true;
}
/**
 * This function validates the outputs to a DELETE request on /templates/{template_id}
 */
export function validateDeleteTemplatesByTemplateIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 204) {
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateDeleteTemplatesByTemplateIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
//# sourceMappingURL=requestValidation.js.map